import 'source-map-support/register';
import type { Context } from 'koishi-core';

export type Config = ((ctx: Context) => Context) | null;

export class MyPlugin {
  config: Config;
  ctx: Context;
  name = 'limit-help';
  apply(ctx: Context, config: Config) {
    this.ctx = ctx;
    this.config = config || ((ctx) => ctx.intersect(() => false));
    this.disableHelp();
  }
  disableHelp() {
    const helpCommand = this.ctx.command('help');
    if (!helpCommand) {
      return;
    }
    const helpCtx = helpCommand.context;
    helpCommand.context = helpCtx.intersect(this.config(helpCtx));
  }
}
